#ifndef FKT_H_INCLUDED
#define FKT_H_INCLUDED
#include <string>
#include <vector>
using namespace std;

/**  Signum-Funktion.
*   @param[in]  x  doppelt genaue reelle Zahl
*   @return     Vorzeichen der Zahl (0 ==> 0)
*/
double sgn(double const x);

/**  Signum-Funktion.
*   @param[in]  x  einfach genaue reelle Zahl
*   @return     Vorzeichen der Zahl (0 ==> 0)
*/
float sgn(float const x);

/**  Demonstration einer weiteren Signatur mit Funktion sgn.
*   @param[in]  x  string
*   @return     Laenge des strings
*/
int sgn(string const x);

/**  Kopiert einen Vektor auf den anderen. Der Vektor @p b wird bei Bedarf reallokiert.
*   @param[in]   a  zu kopierender Vektor
*   @param[out]  b  kopierter Vektor
*/
void copy_vek(vector<int> const& a, vector<int> const& b);

/**  Demonstration der Uebergabe via Refeerenz und Aenderung des Wertes der Variablen.
*   @param[in,out]  a  Zahl
*/
void set_value(int &a);

/**  Meine eigene Powerfunktion. Rekursive Implementierung.
*   @param[in]  x  reelle Zahl
*   @param[in]  k  ganze Zahl >=0
*   @return     x^k
*   @warning    Bricht ab falls k < 0.
*/
float mypow(float const x, int const k);

#endif // FKT_H_INCLUDED
